import { world } from '@minecraft/server';

const possibleEntities = [
    'golems:plank_golem',
    'golems:cobblestone_golem'
];

function handleEntitySpawn(ev) {
    const entity = ev.entity;

    if (entity.typeId === 'minecraft:iron_golem') {
        const location = entity.location;
        const radius = 26;
        const entities = entity.dimension.getEntities();

        let villagerDetected = false;

        entities.forEach(nearbyEntity => {
            const distance = Math.sqrt(
                Math.pow(nearbyEntity.location.x - location.x, 2) +
                Math.pow(nearbyEntity.location.y - location.y, 2) +
                Math.pow(nearbyEntity.location.z - location.z, 2)
            );

            if (distance <= radius && nearbyEntity.typeId === 'minecraft:villager_v2') {
                villagerDetected = true;
            }
        });

        if (villagerDetected) {
            spawnRandomEntityWithEvent(location, entity.dimension);
        }
    }
}

function spawnRandomEntityWithEvent(location, dimension) {
    const randomIndex = Math.floor(Math.random() * possibleEntities.length);
    const entityType = possibleEntities[randomIndex];
    const entity = dimension.spawnEntity(entityType, location);
    const spawnEvent = 'minecraft:from_village';

    if (entity) {
        entity.triggerEvent(spawnEvent);
    }
}

world.afterEvents.entitySpawn.subscribe(handleEntitySpawn);




const impulsePower = 0.25;
const verticalImpulse = 0.15;
world.afterEvents.entityHitEntity.subscribe(event => {
    const attacker = event.damagingEntity;
    const hitEntity = event.hitEntity;

    if (hitEntity.typeId === "golems:plank_golem") {
        const viewDirection = attacker.getViewDirection();
        const vec3 = {
            x: viewDirection.x * impulsePower,
            y: verticalImpulse,
            z: viewDirection.z * impulsePower
        };
        hitEntity.applyImpulse(vec3);
    }
});